EDIT - feature request #10083

Add name relationship type "avoids homonym of"/"causes replacement name"
06/27/2022 01:51 PM - Andreas Mller

Status: Closed Start date:

Priority: Priority14 Due date:

Assignee: Andreas Muller % Done: 100%
Category: cdm Estimated time: 0:00 hour
Target version: Release 5.32

Severity: normal

Description

Currently we have a name relationship type "is blocking name for" with a label "is new combination blocked by" for the inverse
relationship. This relation causes confusion as it is semantically not clear.

Generally we have 3 names to consider if a blocking name exists:

1. replaced synonym

2. blocking name (having the same epithet as the replaced synonym)

3. replacement name (new combination for replaced synonym in the same group as the blocking name so having the same genus
(for species) or specific epithet (for infraspecies), the last epithet is new as it is blocked by the blocking name

Note: there is also a fourth name the potentiall created illegal later homonym, this is related via the later homonym relationship to the
blocking name and therefore not handled here

The relationship between 1->3 is handled by the "is replaced synonym for" relationship. The current "is blocking name" relationship
should handle the relationship between 1->2 according to definitions in the nomenclatural code. However, the inverse label indicates
that it is about the relatioship 2->3.

To better distinguish the 2 latter relationships we should add a new relationship type "avoids homonym of" <-> "causes replacement
name" that represents relationship 2->3 and we need to adapt the inverse label of the current "is blocking name for" relationship to
"has blocking name" (or "is blocked by").

Finally we need to adapt existing data to use the new 2->3 relationship instead of the 1->2 where it was originally meant to be used.

Also we need to adapt the output tools (dataportal, CDM light, ...) to support the new relationshiptype(s) correctly. Also check
TaxEditor if the relationship is correctly supported.

Related issues:

Related to EDIT - feature request #5655: [DISCUSS] Do we need further "non xx... Closed
Related to EDIT - bug #10102: Non-names formatted in italics Closed
Related to EDIT - bug #10122: NameRelationship display should be more configu... New

Associated revisions

Revision 017bce1e - 07/07/2022 10:57 AM - Andreas Muller
ref #10083 add AVOIDS_HOMONYM_OF name relationship

Revision 8b57b93c - 07/22/2022 11:50 PM - Andreas Miiller

ref #10083 update script for blocking reverse label and schema updater for v5.32

Revision bf522fd0 - 07/30/2022 03:19 PM - Andreas Miiller

ref #10083 add "avoids homonym" and "is not" to dataportal settings

Revision f951f099 - 07/30/2022 03:31 PM - Andreas Miiller

ref #10083 add avoids homonym of to nonRelNames in cdmlight

Revision 181447cd - 08/23/2022 03:02 PM - Katja Luther
ref #5655, #10083: fix cdmLight namerelationship handling
History

#1 - 06/27/2022 02:14 PM - Andreas Miiller
- Status changed from New to Discussed

- Priority changed from New to Highest

- % Done changed from 0 to 10

ERS:

das Pendant zu ,jis blocking name for* lautet ,is new combination blocked by*“. Es gibt aber auch den Fall, dass ein neuer Name (nomen novum)
geblockt wird. Spricht etwas dagegen, diese Beziehung einfach ,is blocked by“ oder ,has blocking name* zu nennen?

... ich habe eben noch einmal kurz mit Norbert Gber diese besondere Beziehung gesprochen. Wir stimmen darin tberein, dass ,is blocking name for*
bzw. ,is blocked by“ die Eigenschaft der Beziehung nicht klar ausdrickt.

Denn: blockiert wird ja nicht der legitime Name, sondern ein potentielles illegitimes Homonym, das dann im besten Falle gar nicht erst gebildet wird
und also nicht-existent ist. Wenn solch ein eigentlich blockierter Name dagegen schon existiert, gibt es dafiir schon die Homonym-Beziehung. In
diesen beiden Fallen ist eine Beziehung wie ,is blocked by“ eigentlich irrefihrend.

Wir suchen daher nach einer geeigneteren Formulierung fur die Beziehung zwischen einem Namen, der zur Vermeidung eines illegitimen Homonyms
gebildet wurde, und dem &lteren Namen, der dies notwendig macht.

s,[nomen novum] avoids homonym of [blocking name]“

Und umgekehrt

“[blocking name] causes replacement name [nomen novum]”
Oder so &hnlich... Vorschlage willkommen!

WHK:

die Vorschlage von Eckhard finde ich klar, versténdlich und mir ist keine bessere Formulierung eingefallen (nur schlechtere Formulierungen).
WGB:

mir fallt auch nichts eleganteres ein — Nick?

NT:

Norbert/Eckhards Vorschlag geféllt mir auch.

#2 - 06/27/2022 02:18 PM - Andreas Miiller

AM:

diese Mail ist letztes Jahr leider bei mir liegen geblieben. Aus aktuellem Anlass wiirde ich sie gerne wieder aufgreifen und habe ein Ticket daftr
angelegt: #10083

Das Ticket pladiert dafir, fr die 3 Namen

1. replaced synonym
2. blocking name
3. replacement name

3 Relationstypen anzubieten:
I is replaced synonym for/is new name for (1->3)
II. is blocking name for/has blocking name (1->2)

Ill. avoids homonym of/ causes replacement name (2->3)

Die bisherige Kombination ,is blocking name‘/“is new combination blocked by” wiirde dann wegfallen, da sie in der inversen Richtung einen anderen
Relationstyp (namlich IIl.) darstellt, als in der direkten Richtung (ll.).

Existierende Daten missten im Anschluss dann noch korrekt angepasst werden.

Relationstyp Il und Ill scheinen beide gebraucht zu werden, da einige Projekte in der Ausgabe lieber die 3. Beziehung ausgeben, andere lieber die 2.
Beziehung, wobei sich mit etwas taxonomischem Wissen die beiden Beziehungen natirlich ineinander tberfiihren lassen (was theoretisch erlauben
wirde, die Beziehung Ill wegzulassen, dies wiirde aber vieles komplexer machen und ist daher weniger wiinschenswert).

Je nach Projekt kann stattdessen der nicht gewlinschte Relationstyp tber die Preferences ausgeblendet werden.

Ich hoffe, dies entspricht der Intention dieses &lteren Email-Threads. Falls ihr noch Anderungsvorschlage habt, lasst es mich bitte méglichst bis
Mittwoch Abend (29.6.) wissen, ansonsten wirde ich dann mit der Implementierung beginnen.
#3 - 06/27/2022 02:21 PM - Andreas Miiller
- Target version changed from CDM UML 5.43 to Release 5.32

Separate discussion WGB-AM:

AM

ja, das war semantisch nie einfach, was bei blocking name was ist bzw. bedeuten soll. Fir Cuba mussten wir da ein aufwendiges Script schreiben,
um die Daten nochmal umzuhangen, da sie zuerst falsch interpretiert wurden: https://dev.e-taxonomy.eu/redmine/issues/6024 ). Es ist da leider auch
noch etwas offen, siehe die Mails im Anhang, die noch nicht abgearbeitet sind, zumindest die von Nick als letztem Threadautor.

Das Problem ist ja, dass es mind. 2 blocking Beziehungen gibt, die zwischen Blocking Name und Replaced Synonym und die zwischen Bl.name und
Replacement name (s. https://dev.e-taxonomy.eu/redmine/issues/5655). Die einen wollen v.a. letztere Anzeigen (s. Mail Eckhard) die anderen wie du
jetzt wohl die erstere.

Und dann gibt es noch die allgemeinen ,non“ Beziehungen und die Tatsache, dass die Blocking Names sich ja wenn man so will auf die ganze
homotypische Gruppe beziehen.

Wir missten also die existierende Beziehung splitten, wenn ich es richtig verstehe, gute Labels finden (fur die 2. Beziehungen haben Eckhard und
Norbert ja schon was vorgeschlagen) und dann pro Datenbank/Datensatz anschauen, was jeweils gemeint war.

WGB:

ich habe mir die Mail von Eckhard angesehen, er sagt ja eigentlich genau das gleiche wie ich — die logische Beziehung besteht zwischen dem
replaced synonym und dem blocking name.

Die Beziehung zwischen dem nomen novum und dem replaced synonym wird ja getrennt hergestellt.

Der Unterschied liegt darin, wo der blocking Name ausgegeben wird, Greuter (der ja vielfach aus Platzgriinden Sachen einfach verkirzt darstellt) und
er wollen den den blocking name direkt zum nomen novum stellen, das wére dann durch die ,is new combination blocked by* Sache (die man aber
auch aus den beiden obigen Beziehungen ausgabeseitig herstellen kénnte).

Norberts und Nicks Vorschlage machen ja nur expliziter, was durch den (im Code definierten) Begriff (replaced synonym) schon ausgedriickt wird. Ich
wirde diese Beziehungen dann fir ,meine” Datenbanken ausblenden, falsch sind sie ja nicht.

Was ich aber brauche ist die direkte gerichtete Beziehung zwischen den Namen (nicht unbedingt den homotypischen Gruppen, da dort ja auch noch
andere Epitheta vorkommen kdnnen), also ,has blocking name* oder s blocked by“ und von mir aus auch (das dann immer auch automatisch zu
setzende) ,is blocking name for*.

AM:
ich bin mir jetzt nicht ganz sicher, ob ich deine Mail richtig interpretiere, aber so wie ich sie interpretiere, widerspricht sie nicht meiner Mail, oder?

Also mein Vorschlag ,die existierenden Beziehungen zu splitten“ meint ja im Prinzip, dass wir fir jede der 3 méglichen Namensbeziehungen
zwischen den 3 Namen (replaced synonym, blocking name, replacement name) auch explizit eine Beziehung im Model haben sollten. Also

« is replaced synonym for <-> is replacement name for
* is blocked by <-> is blocking name for
* avoids homonym of <-> causes replacement name

Die bisherige Beziehung ,is blocking name for” <-> ,is new combination blocked by” ist nattrlich insofern Quatsch, als dass sie das direct label der 2.
Beziehung und das inverse label der dritten Beziehung kombiniert, was offensichtlich semantisch nicht korrekt ist. Woher diese Kombination kommt
ist mir Gbrigens unklar. Im CDM war sie wohl von Anfang an drin, ob das irgendwo abgeschrieben wurde, konnte ich aber nicht rausfinden.

Du deutest in deiner Mail unten an, dass die 3. Beziehung aus den beiden ersteren hergeleitet werden und damit evtl. auch weggelassen werden
kénnte, auch wenn die dritte und nicht die zweite Beziehung bei der Ausgabe angezeigt werden soll. Grundsatzlich stimmt das nattrlich, aber die
Lésung finde ich aus mehreren Griinden nicht gut:

* es setzt Vollstéandigkeit der Daten voraus, die langst nicht immer gegeben ist (Importe, Umgehung der aufwendigen Dateneingabe, dirty data im
Allgemeinen, ...)

« es verkompliziert die Formatierungsregeln und verringert die Performance bei der Formatierung

« es ist fir den User weniger versténdlich und setzt explizites Wissen voraus in einem Bereich, der auch fir viele Taxonomen nicht auf den ersten
Blick so eindeutig ist

Daher wirde ich jetzt den dritten Relationstyp zusétzlich einfihren und das inverse Label des zweiten Relationstyps umbenennen. Im Anschluss
mussen wir noch Altdaten korrekt anpassen, z.B. in E+M. Das haben wir bei Cuba ja schon mal gemacht und es sollte halbautomatisiert méglich sein,
da ja aus den Epitheten der Namen eigentlich immer ersichtlich sein sollte, ob der zweite oder der dritte Relationstyp gemeint ist.

WGB:

klingt gut! Da man die in einem Projekt verfiigbaren Name Relationships ja konfigurieren kann, macht es ja nichts, wenn da ein paar mehr sind.

#4 - 07/07/2022 02:35 PM - Andreas Miiller

- Status changed from Discussed to Resolved

- % Done changed from 10 to 70
The relationship was added. We still need an update script or handling for the inverse label and for existing data.

#5 - 07/08/2022 04:20 PM - Andreas Miiller

SELECT r.id rellId, nl.titleCache nl, t.titleCache rel, n2.titleCache n2, nl.nameCache nlshort, n2.nameCache n2
short
FROM NameRelationship r INNER JOIN TaxonName nl ON nl.id = r.relatedfrom_id INNER JOIN TaxonName n2 ON n2.id =
r.relatedto_id
INNER JOIN DefinedTermBase t ON t.id = r.type_id
WHERE t.uuid = 'ldab357f-2el12-4511-97a4-e5153589%e6a6"';

e Caryo_amaranth: 1
Caryo_spp: 1
Cichorieae: 6
euromed: 167
euromed_caucasus: 1
cuba: 214

greece: 7

#6 - 07/08/2022 04:32 PM - Andreas Miiller
- % Done changed from 70 to 90
Update script is written and checked on integration.

Dataportal and cdmlight(?) still need to be updated.
Relationships need to be updated manually after release.

#7 - 07/30/2022 04:15 PM - Andreas Miiller
- Related to feature request #5655: [DISCUSS] Do we need further "non xxx" relations? added

#8 - 07/30/2022 04:20 PM - Andreas Miiller
Dataportal and cdmlight updated cdm-dataportal|bf522fd0e17 and f951f09989936db85

| created a temporary example page at

https://test.e-taxonomy.eu/dataportal/preview/cyprus/cdm_dataportal/taxon/336a8807-05e1-4922-b5c9-a6e43f1e02da/synonymy

#9 - 07/30/2022 04:21 PM - Andreas Miiller
- Priority changed from Highest to Priority14

#10 - 07/30/2022 05:23 PM - Andreas Miiller
- Related to bug #10102: Non-names formatted in italics added

#11 - 07/30/2022 07:54 PM - Andreas Miiller
Before fully closing also check #5655

#12 - 08/02/2022 04:38 PM - Andreas Miiller

- Assignee changed from Andreas Muiller to Katja Luther

Mail sent to datamanager to adapt their data (list of effected DBs see #note-5).

Katja, could you please check if it works correctly in cdmlight and dataportal (and if it is correctly implemented)? And then close the ticket?

Please also check #5655 (non-specific "non"-relationship) for correct implementation in cdmlight and dataportal as it was not implemented before (at
least not for the dataportal).

#13 - 08/23/2022 01:21 PM - Katja Luther
Andreas Muller wrote in #note-12:

Mail sent to datamanager to adapt their data (list of effected DBs see #note-5).

Katja, could you please check if it works correctly in cdmlight and dataportal (and if it is correctly implemented)? And then close the ticket?

The dataportal implementation is correct!

Please also check #5655 (non-specific "non"-relationship) for correct implementation in cdmlight and dataportal as it was not implemented before
(at least not for the dataportal).

#14 - 08/24/2022 11:12 AM - Katja Luther

Actually there was a bug in cdmLight, this is fixed. Now the namerelationships are exported to the NameRelationship.csv and in HomotypicGroup.csv,
here it depends on the configuration whether the label is shown for both directions (config: ShowlnverseNameRelationsiInHomotypicGroup).

Maybe we should discuss to split this configuration for the different Namerelationship Types.
-> create new ticket for configurable namerelationships (#10122)

#15 - 08/24/2022 02:46 PM - Katja Luther
- Related to bug #10122: NameRelationship display should be more configurable in cdmLight added

#16 - 08/24/2022 03:05 PM - Andreas Miiller
- Status changed from Resolved to Closed
- Assignee changed from Katja Luther to Andreas Miiller

- % Done changed from 90 to 100

Should be fixed. Open issues moved to related tickets.

04/24/2024 5/5


https://dev.e-taxonomy.eu/redmine/issues/10122
http://www.tcpdf.org

